'OPTIMIZATIONS:
'Work on ENTITIES.

Type TProfiling
	Field startTime:Long
	Field endTime:Long
	Field length:Long
	Field length2:Long 'The one that's drawn on screen
	Field name:String 
End Type

Global gProfilings:TMap = CreateMap()

Function MakeProfiling(name:String)
	Local p:TProfiling = New TProfiling
	p.name = name
	MapInsert gProfilings, name, p
End Function

Function ProfileInit()
	ClearMap gProfilings
	MakeProfiling("WALL RENDER")
	MakeProfiling("FLOORS")
	MakeProfiling("ENTITIES")
	MakeProfiling("MONSTERS")
	MakeProfiling("PARTICLES")
	MakeProfiling("HUD")
End Function

Function ProfileStart(name:String)
	Local p:TProfiling = TProfiling(MapValueForKey(gProfilings, name))
	
	Assert p, "PROFILE NAME INVALID"
	
	p.startTime = MilliSecs()
End Function

Function ProfileEnd(name:String)
	Local p:TProfiling = TProfiling(MapValueForKey(gProfilings, name))
	
	Assert p, "PROFILE NAME INVALID"
	
	p.endTime = MilliSecs()
	p.length :+ p.endTime - p.startTime
End Function

Function ProfileUpdate()
	For Local p:TProfiling = EachIn MapValues(gProfilings)
		p.length2 = p.length
		p.length = 0
		p.startTime = 0
		p.endTime = 0
	Next
End Function

Function ProfileRender()
	If DEBUG = True Then
		Local cnt:Int = 0
		For Local p:TProfiling = EachIn MapValues(gProfilings)
			cnt :+ 1
			DrawString(p.name + " " + p.length2 + " MS", gFont, 0, 64 + (cnt * 8), 8)
			'DebugStop()
		Next
	EndIf
	'DebugStop()
End Function